diff --git a/rsvg-text.c b/rsvg-text.c
index 05353dd..52e52c3 100644
--- a/rsvg-text.c
+++ b/rsvg-text.c
@@ -601,350 +592,44 @@ rsvg_text_layout_new (RsvgDrawingCtx * ctx, RsvgState * state, const char *text)
     return layout;
 }
 
-#ifdef CAIRO_HAS_FT_FONT
-static FT_Int32
-rsvg_text_layout_render_flags (RsvgTextLayout * layout)
-{
-    gint flags = 0;
-
-    flags |= FT_LOAD_NO_BITMAP;
-    flags |= FT_LOAD_TARGET_MONO;
-    flags |= FT_LOAD_NO_HINTING;
-
-    return flags;
-}
-
-static void
-rsvg_text_vector_coords (RenderCtx * ctx, const FT_Vector * vector, gdouble * x, gdouble * y)
-{
-    *x = ctx->offset_x + (double) vector->x / 64;
-    *y = ctx->offset_y - (double) vector->y / 64;
-}
-
-static gint
-moveto (const FT_Vector * to, gpointer data)
-{
-    RenderCtx *ctx;
-    gchar buf[G_ASCII_DTOSTR_BUF_SIZE];
-    gdouble x, y;
-
-    ctx = (RenderCtx *) data;
-
-    if (ctx->wrote)
-        g_string_append (ctx->path, "Z ");
-    else
-        ctx->wrote = TRUE;
-
-    g_string_append_c (ctx->path, 'M');
-
-    rsvg_text_vector_coords (ctx, to, &x, &y);
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), x));
-    g_string_append_c (ctx->path, ',');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), y));
-    g_string_append_c (ctx->path, ' ');
-
-    return 0;
-}
-
-static gint
-lineto (const FT_Vector * to, gpointer data)
-{
-    RenderCtx *ctx;
-    gchar buf[G_ASCII_DTOSTR_BUF_SIZE];
-    gdouble x, y;
-
-    ctx = (RenderCtx *) data;
-
-    if (!ctx->wrote)
-        return 0;
-
-    g_string_append_c (ctx->path, 'L');
-
-    rsvg_text_vector_coords (ctx, to, &x, &y);
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), x));
-    g_string_append_c (ctx->path, ',');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), y));
-    g_string_append_c (ctx->path, ' ');
-
-    return 0;
-}
-
-static gint
-conicto (const FT_Vector * ftcontrol, const FT_Vector * to, gpointer data)
-{
-    RenderCtx *ctx;
-    gchar buf[G_ASCII_DTOSTR_BUF_SIZE];
-    gdouble x, y;
-
-    ctx = (RenderCtx *) data;
-
-    if (!ctx->wrote)
-        return 0;
-
-    g_string_append_c (ctx->path, 'Q');
-
-    rsvg_text_vector_coords (ctx, ftcontrol, &x, &y);
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), x));
-    g_string_append_c (ctx->path, ',');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), y));
-
-    rsvg_text_vector_coords (ctx, to, &x, &y);
-    g_string_append_c (ctx->path, ' ');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), x));
-    g_string_append_c (ctx->path, ',');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), y));
-    g_string_append_c (ctx->path, ' ');
-
-    return 0;
-}
-
-static gint
-cubicto (const FT_Vector * ftcontrol1,
-         const FT_Vector * ftcontrol2, const FT_Vector * to, gpointer data)
-{
-    RenderCtx *ctx;
-    gchar buf[G_ASCII_DTOSTR_BUF_SIZE];
-    gdouble x, y;
-
-    ctx = (RenderCtx *) data;
-
-    if (!ctx->wrote)
-        return 0;
-
-    g_string_append_c (ctx->path, 'C');
-
-    rsvg_text_vector_coords (ctx, ftcontrol1, &x, &y);
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), x));
-    g_string_append_c (ctx->path, ',');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), y));
-
-    rsvg_text_vector_coords (ctx, ftcontrol2, &x, &y);
-    g_string_append_c (ctx->path, ' ');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), x));
-    g_string_append_c (ctx->path, ',');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), y));
-
-    rsvg_text_vector_coords (ctx, to, &x, &y);
-    g_string_append_c (ctx->path, ' ');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), x));
-    g_string_append_c (ctx->path, ',');
-    g_string_append (ctx->path, g_ascii_dtostr (buf, sizeof (buf), y));
-    g_string_append_c (ctx->path, ' ');
-
-    return 0;
-}
-
-static gint
-rsvg_text_layout_render_glyphs (RsvgTextLayout * layout,
-                                PangoFont * font,
-                                PangoGlyphString * glyphs,
-                                RsvgTextRenderFunc render_func,
-                                gint x, gint y, gpointer render_data)
-{
-    PangoGlyphInfo *gi;
-    FT_Int32 flags;
-    FT_Vector pos;
-    gint i;
-    gint x_position = 0;
-
-    flags = rsvg_text_layout_render_flags (layout);
-
-    for (i = 0, gi = glyphs->glyphs; i < glyphs->num_glyphs; i++, gi++) {
-        if (gi->glyph) {
-            pos.x = x + x_position + gi->geometry.x_offset;
-            pos.y = y + gi->geometry.y_offset;
-
-            render_func (font, gi->glyph, flags, pos.x, pos.y, render_data);
-        }
-
-        x_position += glyphs->glyphs[i].geometry.width;
-    }
-    return x_position;
-}
-
-static void
-rsvg_text_render_vectors (PangoFont * font,
-                          PangoGlyph pango_glyph, FT_Int32 flags, gint x, gint y, gpointer ud)
-{
-    static const FT_Outline_Funcs outline_funcs = {
-        (FT_Outline_MoveToFunc) moveto,
-        (FT_Outline_LineToFunc) lineto,
-        (FT_Outline_ConicToFunc) conicto,
-        (FT_Outline_CubicToFunc) cubicto,
-        0,
-        0
-    };
-
-    FT_Face face;
-    FT_Glyph glyph;
-
-    RenderCtx *context = (RenderCtx *) ud;
-
-    face = pango_ft2_font_get_face (font);
-
-    if (0 != FT_Load_Glyph (face, (FT_UInt) pango_glyph, flags))
-		return;
-
-    if (0 != FT_Get_Glyph (face->glyph, &glyph))
-		return;
-
-    if (face->glyph->format == FT_GLYPH_FORMAT_OUTLINE) {
-        FT_OutlineGlyph outline_glyph = (FT_OutlineGlyph) glyph;
-
-        context->offset_x = (gdouble) x / PANGO_SCALE;
-        context->offset_y = (gdouble) y / PANGO_SCALE - (int) face->size->metrics.ascender / 64;
-
-        FT_Outline_Decompose (&outline_glyph->outline, &outline_funcs, context);
-    }
-
-    FT_Done_Glyph (glyph);
-}
-#else 
-static gint
-rsvg_text_layout_render_glyphs (RsvgTextLayout * layout,
-                                PangoFont * font,
-                                PangoGlyphString * glyphs,
-                                RsvgTextRenderFunc render_func,
-                                gint x, gint y, gpointer render_data)
-{
-    PangoGlyphInfo *gi;
-    gint i;
-    gint x_position = 0;
-    gint pos_x, pos_y;
-    
-    for (i = 0, gi = glyphs->glyphs; i < glyphs->num_glyphs; i++, gi++) {
-        if (gi->glyph) {
-            pos_x = x + x_position + gi->geometry.x_offset;
-            pos_y = y + gi->geometry.y_offset;
-
-            render_func (font, gi->glyph, pos_x, pos_y, render_data);
-        }
-
-        x_position += glyphs->glyphs[i].geometry.width;
-    }
-
-    return x_position;
-}
-
-static void
-rsvg_text_render_vectors (PangoFont * font,
-                          PangoGlyph pango_glyph, gint x, gint y, gpointer ud)
-{
-}
-#endif /* CAIRO_HAS_FT_FONT */
-
-static void
-rsvg_text_layout_render_line (RsvgTextLayout * layout,
-                              PangoLayoutLine * line,
-                              RsvgTextRenderFunc render_func, gint x, gint y, gpointer render_data)
-{
-    GSList *list;
-    gint x_off = 0;
-
-    for (list = line->runs; list; list = list->next) {
-        PangoLayoutRun *run = list->data;
-
-        x_off += rsvg_text_layout_render_glyphs (layout,
-                                                 run->item->analysis.font, run->glyphs,
-                                                 render_func, x + x_off, y, render_data);
-
-    }
-}
-
-static void
-rsvg_text_layout_render (RsvgTextLayout * layout,
-                         RsvgTextRenderFunc render_func, gpointer render_data)
-{
-    PangoLayoutIter *iter;
-    gint x, y;
-
-    x = layout->x;
-    y = layout->y;
-
-    x *= PANGO_SCALE;
-    y *= PANGO_SCALE;
-
-    iter = pango_layout_get_iter (layout->layout);
-
-    if (iter) {
-        PangoRectangle logical;
-        PangoLayoutLine *line;
-        gint baseline;
-
-        line = pango_layout_iter_get_line (iter);
-
-        pango_layout_iter_get_line_extents (iter, NULL, &logical);
-        baseline = pango_layout_iter_get_baseline (iter);
-
-        rsvg_text_layout_render_line (layout, line,
-                                      render_func, x, y + baseline, render_data);
-
-        layout->x += logical.width / (double)PANGO_SCALE;
-    }
-
-    pango_layout_iter_free (iter);
-}
-
-static GString *
-rsvg_text_render_text_as_string (RsvgDrawingCtx * ctx, const char *text, gdouble * x, gdouble * y)
-{
-    RsvgTextLayout *layout;
-    RenderCtx *render;
-    RsvgState *state;
-    GString *output;
-    state = rsvg_state_current (ctx);
-
-    state->fill_rule = FILL_RULE_EVENODD;
-    state->has_fill_rule = TRUE;
-
-    layout = rsvg_text_layout_new (ctx, state, text);
-    layout->x = *x;
-    layout->y = *y;
-    layout->orientation = rsvg_state_current (ctx)->text_dir == PANGO_DIRECTION_TTB_LTR ||
-        rsvg_state_current (ctx)->text_dir == PANGO_DIRECTION_TTB_RTL;
-    render = rsvg_render_ctx_new ();
-
-    rsvg_text_layout_render (layout, rsvg_text_render_vectors, (gpointer) render);
-
-    if (render->wrote)
-        g_string_append_c (render->path, 'Z');
-
-    *x = layout->x;
-    *y = layout->y;
-
-    output = g_string_new (render->path->str);
-    rsvg_render_ctx_free (render);
-    rsvg_text_layout_free (layout);
-    return output;
-}
-
 void
 rsvg_text_render_text (RsvgDrawingCtx * ctx, const char *text, gdouble * x, gdouble * y)
 {
-    if (ctx->render->create_pango_context && ctx->render->render_pango_layout) {
-        PangoContext *context;
-        PangoLayout *layout;
-        PangoLayoutIter *iter;
-        RsvgState *state;
-        gint w, h, baseline;
-
-        state = rsvg_state_current (ctx);
-        context = ctx->render->create_pango_context (ctx);
-        layout = rsvg_text_create_layout (ctx, state, text, context);
-        pango_layout_get_size (layout, &w, &h);
-        iter = pango_layout_get_iter (layout);
-        baseline = pango_layout_iter_get_baseline (iter) / (double)PANGO_SCALE;
-        pango_layout_iter_free (iter);
-        ctx->render->render_pango_layout (ctx, layout, *x, *y - baseline);
-        *x += w / (double)PANGO_SCALE;
-        g_object_unref (layout);
-        g_object_unref (context);
+    PangoContext *context;
+    PangoLayout *layout;
+    PangoLayoutIter *iter;
+    RsvgState *state;
+    gint w, h;
+    double offset_x, offset_y, offset;
+
+    state = rsvg_current_state (ctx);
+
+    /* Do not render the text if the font size is zero. See bug #581491. */
+    if (state->font_size.length == 0)
+        return;
+
+    context = ctx->render->create_pango_context (ctx);
+    layout = rsvg_text_create_layout (ctx, state, text, context);
+    pango_layout_get_size (layout, &w, &h);
+    iter = pango_layout_get_iter (layout);
+    offset = pango_layout_iter_get_baseline (iter) / (double) PANGO_SCALE;
+    offset += _rsvg_css_accumulate_baseline_shift (state, ctx);
+    if (PANGO_GRAVITY_IS_VERTICAL (state->text_gravity)) {
+        offset_x = -offset;
+        offset_y = 0;
     } else {
-        GString *render;
-        render = rsvg_text_render_text_as_string (ctx, text, x, y);
-        rsvg_render_path (ctx, render->str);
-        g_string_free (render, TRUE);
+        offset_x = 0;
+        offset_y = offset;
     }
+    pango_layout_iter_free (iter);
+    ctx->render->render_pango_layout (ctx, layout, *x - offset_x, *y - offset_y);
+    if (PANGO_GRAVITY_IS_VERTICAL (state->text_gravity))
+        *y += w / (double)PANGO_SCALE;
+    else
+        *x += w / (double)PANGO_SCALE;
+
+    g_object_unref (layout);
+    g_object_unref (context);
 }
 
 static gdouble
@@ -963,10 +648,8 @@ rsvg_text_length_text_as_string (RsvgDrawingCtx * ctx, const char *text)
     RsvgTextLayout *layout;
     gdouble x;
 
-    layout = rsvg_text_layout_new (ctx, rsvg_state_current (ctx), text);
+    layout = rsvg_text_layout_new (ctx, rsvg_current_state (ctx), text);
     layout->x = layout->y = 0;
-    layout->orientation = rsvg_state_current (ctx)->text_dir == PANGO_DIRECTION_TTB_LTR ||
-        rsvg_state_current (ctx)->text_dir == PANGO_DIRECTION_TTB_RTL;
 
     x = rsvg_text_layout_width (layout);
 
diff --git a/rsvg-text.h b/rsvg-text.h
index 7cb0890..185f8ba 100644
--- a/rsvg-text.h
+++ b/rsvg-text.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-text.h: Text handling routines for RSVG
 
@@ -31,9 +32,13 @@
 
 G_BEGIN_DECLS 
 
+G_GNUC_INTERNAL
 RsvgNode    *rsvg_new_text	    (void);
+G_GNUC_INTERNAL
 RsvgNode    *rsvg_new_tspan	    (void);
+G_GNUC_INTERNAL
 RsvgNode    *rsvg_new_tref	    (void);
+G_GNUC_INTERNAL
 char	    *rsvg_make_valid_utf8   (const char *str, int len);
 
 G_END_DECLS
diff --git a/rsvg-xml.c b/rsvg-xml.c
new file mode 100644
index 0000000..31f7ef0
--- /dev/null
+++ b/rsvg-xml.c
@@ -0,0 +1,96 @@
+/*
+ * Copyright © 2010 Christian Persch
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of the
+ * License, or (at your option) any later version.
+  
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+  
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this program; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+*/
+
+#include "config.h"
+
+#include "rsvg-xml.h"
+
+typedef struct {
+    GInputStream *stream;
+    GCancellable *cancellable;
+    GError      **error;
+} RsvgXmlInputStreamContext;
+
+/* this should use gsize, but libxml2 is borked */
+static int
+context_read (RsvgXmlInputStreamContext *context,
+              char *buffer,
+              int   len)
+{
+    gssize n_read;
+
+    if (*(context->error))
+        return -1;
+
+    n_read = g_input_stream_read (context->stream, buffer, (gsize) len,
+                                  context->cancellable,
+                                  context->error);
+    if (n_read < 0)
+        return -1;
+
+    return (int) n_read;
+}
+
+static int
+context_close (RsvgXmlInputStreamContext *context)
+{
+    gboolean ret;
+
+    /* Don't overwrite a previous error */
+    ret = g_input_stream_close (context->stream, context->cancellable,
+                                *(context->error) == NULL ? context->error : NULL);
+
+    g_object_unref (context->stream);
+    if (context->cancellable)
+        g_object_unref (context->cancellable);
+    g_slice_free (RsvgXmlInputStreamContext, context);
+
+    return ret ? 0 : -1;
+}
+
+/**
+ * _rsvg_xml_input_buffer_new_from_stream:
+ * @context: a #xmlParserCtxtPtr
+ * @input_stream: a #GInputStream
+ *
+ * Returns: a new #xmlParserInputPtr wrapping @input_stream
+ */
+xmlParserInputBufferPtr
+_rsvg_xml_input_buffer_new_from_stream (GInputStream   *stream,
+                                        GCancellable   *cancellable,
+                                        xmlCharEncoding enc,
+                                        GError        **error)
+
+{
+    RsvgXmlInputStreamContext *context;
+
+    g_return_val_if_fail (G_IS_INPUT_STREAM (stream), NULL);
+    g_return_val_if_fail (cancellable == NULL || G_IS_CANCELLABLE (cancellable), NULL);
+    g_return_val_if_fail (error != NULL, NULL);
+
+    context = g_slice_new (RsvgXmlInputStreamContext);
+    context->stream = g_object_ref (stream);
+    context->cancellable = cancellable ? g_object_ref (cancellable) : NULL;
+    context->error = error;
+
+    return xmlParserInputBufferCreateIO ((xmlInputReadCallback) context_read,
+                                         (xmlInputCloseCallback) context_close,
+                                         context,
+                                         enc);
+}
diff --git a/rsvg-xml.h b/rsvg-xml.h
new file mode 100644
index 0000000..95158d8
--- /dev/null
+++ b/rsvg-xml.h
@@ -0,0 +1,35 @@
+/*
+ * Copyright © 2010 Christian Persch
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of the
+ * License, or (at your option) any later version.
+  
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+  
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this program; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+*/
+
+#ifndef RSVG_XML_H
+#define RSVG_XML_H
+
+#include <libxml/xmlIO.h>
+#include <gio/gio.h>
+
+G_BEGIN_DECLS
+
+xmlParserInputBufferPtr _rsvg_xml_input_buffer_new_from_stream (GInputStream   *stream,
+                                                                GCancellable   *cancellable,
+                                                                xmlCharEncoding enc,
+                                                                GError        **error);
+
+G_END_DECLS
+
+#endif /* !RSVG_XML_H */
diff --git a/rsvg.c b/rsvg.c
index 2f7c71c..31c4baf 100644
--- a/rsvg.c
+++ b/rsvg.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg.c: SAX-based renderer for SVG files into a GdkPixbuf.
 
@@ -43,26 +44,20 @@
 #include "rsvg-cairo.h"
 #include "rsvg-cairo-draw.h"
 
-static void
-rsvg_pixmap_destroy (gchar * pixels, gpointer data)
-{
-    g_free (pixels);
-}
-
 /**
  * rsvg_handle_get_pixbuf_sub:
  * @handle: An #RsvgHandle
- * @id: The id of an element inside the SVG, or %NULL to render the whole SVG. For
- * example, if you have a layer called "layer1" that you wish to render, pass 
- * "##layer1" as the id.
+ * @id: (nullable): The id of an element inside the SVG, or %NULL to
+ * render the whole SVG. For example, if you have a layer called
+ * "layer1" that you wish to render, pass "##layer1" as the id.
  *
- * Returns the pixbuf loaded by #handle.  The pixbuf returned will be reffed, so
+ * Returns the pixbuf loaded by @handle.  The pixbuf returned will be reffed, so
  * the caller of this function must assume that ref.  If insufficient data has
  * been read to create the pixbuf, or an error occurred in loading, then %NULL
  * will be returned.  Note that the pixbuf may not be complete until
  * @rsvg_handle_close has been called.
  *
- * Returns: the pixbuf loaded by #handle, or %NULL.
+ * Returns: (transfer full) (nullable): the pixbuf loaded by @handle, or %NULL.
  *
  * Since: 2.14
  **/
@@ -71,10 +66,8 @@ rsvg_handle_get_pixbuf_sub (RsvgHandle * handle, const char *id)
 {
     RsvgDimensionData dimensions;
     GdkPixbuf *output = NULL;
-    guint8 *pixels;
     cairo_surface_t *surface;
     cairo_t *cr;
-    int rowstride;
 
     g_return_val_if_fail (handle != NULL, NULL);
 
@@ -85,36 +78,26 @@ rsvg_handle_get_pixbuf_sub (RsvgHandle * handle, const char *id)
     if (!(dimensions.width && dimensions.height))
         return NULL;
 
-    rowstride = dimensions.width * 4;
-
-    pixels = g_try_malloc0 (dimensions.width * dimensions.height * 4);
-    if (!pixels)
+    surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32,
+                                          dimensions.width, dimensions.height);
+    if (cairo_surface_status (surface) != CAIRO_STATUS_SUCCESS) {
+        cairo_surface_destroy (surface);
         return NULL;
+    }
 
-    surface = cairo_image_surface_create_for_data (pixels,
-                                                   CAIRO_FORMAT_ARGB32,
-                                                   dimensions.width, dimensions.height, rowstride);
     cr = cairo_create (surface);
-    cairo_surface_destroy (surface);
 
-    if (rsvg_handle_render_cairo_sub (handle, cr, id)) {
-		rsvg_cairo_to_pixbuf (pixels, rowstride, dimensions.height);
-
-		output = gdk_pixbuf_new_from_data (pixels,
-										   GDK_COLORSPACE_RGB,
-										   TRUE,
-										   8,
-										   dimensions.width,
-										   dimensions.height,
-										   rowstride,
-										   (GdkPixbufDestroyNotify) rsvg_pixmap_destroy, NULL);
-	} else {
-		g_free (pixels);
-		output = NULL;
-	}
+    if (!rsvg_handle_render_cairo_sub (handle, cr, id)) {
+        cairo_destroy (cr);
+        cairo_surface_destroy (surface);
+        return NULL;
+    }
 
     cairo_destroy (cr);
 
+    output = rsvg_cairo_surface_to_pixbuf (surface);
+    cairo_surface_destroy (surface);
+
     return output;
 }
 
@@ -122,13 +105,13 @@ rsvg_handle_get_pixbuf_sub (RsvgHandle * handle, const char *id)
  * rsvg_handle_get_pixbuf:
  * @handle: An #RsvgHandle
  *
- * Returns the pixbuf loaded by #handle.  The pixbuf returned will be reffed, so
+ * Returns the pixbuf loaded by @handle.  The pixbuf returned will be reffed, so
  * the caller of this function must assume that ref.  If insufficient data has
  * been read to create the pixbuf, or an error occurred in loading, then %NULL
  * will be returned.  Note that the pixbuf may not be complete until
  * @rsvg_handle_close has been called.
  *
- * Returns: the pixbuf loaded by #handle, or %NULL.
+ * Returns: (transfer full) (nullable): the pixbuf loaded by @handle, or %NULL.
  **/
 GdkPixbuf *
 rsvg_handle_get_pixbuf (RsvgHandle * handle)
